searchData={"items":[{"type":"module","title":"LiveVue","doc":"","ref":"LiveVue.html"},{"type":"function","title":"LiveVue.vue/1","doc":"","ref":"LiveVue.html#vue/1"},{"type":"function","title":"Attributes - LiveVue.vue/1","doc":"* `v-component` (`:string`) (required) - Name of the Vue component.Examples include `\"YourComponent\"`, and `\"directory/Example\"`.\n* `class` (`:string`) - Class to apply to the Vue component. Defaults to `nil`.\n* `v-ssr` (`:boolean`) - Whether to render the component on the server. Defaults to `nil`.\n* `v-socket` (`:map`) - LiveView socket, should be provided when rendering inside LiveView. Defaults to `nil`.\n* Global attributes are accepted.","ref":"LiveVue.html#vue/1-attributes"},{"type":"module","title":"LiveVue.Components","doc":"Macros to improve the developer experience of crossing the Liveview/Vue boundary.","ref":"LiveVue.Components.html"},{"type":"macro","title":"LiveVue.Components.__using__/1","doc":"Generates functions local to your current module that can be used to render Vue components.\nTODO: This could perhaps be optimized to only read the files once per compilation.","ref":"LiveVue.Components.html#__using__/1"},{"type":"macro","title":"Examples - LiveVue.Components.__using__/1","doc":"```elixir\nuse LiveVue.Components, vue_root: \"./assets/vue/*.vue\"\n```","ref":"LiveVue.Components.html#__using__/1-examples"},{"type":"module","title":"LiveVue.Reload","doc":"","ref":"LiveVue.Reload.html"},{"type":"function","title":"LiveVue.Reload.vite_assets/1","doc":"Renders the vite assets in development, and in production falls back to normal compiled assets","ref":"LiveVue.Reload.html#vite_assets/1"},{"type":"function","title":"Attributes - LiveVue.Reload.vite_assets/1","doc":"* `assets` (`:list`) (required)","ref":"LiveVue.Reload.html#vite_assets/1-attributes"},{"type":"function","title":"Slots - LiveVue.Reload.vite_assets/1","doc":"* `inner_block` (required) - what should be rendered when Vite path is not defined.","ref":"LiveVue.Reload.html#vite_assets/1-slots"},{"type":"behaviour","title":"LiveVue.SSR","doc":"A behaviour for rendering Vue components server-side.\n\nTo define a custom renderer, change the application config in `config.exs`:\n\n    config :live_vue, ssr_module: MyCustomSSRModule\n\nExposes a telemetry span for each render under key `[:live_vue, :ssr]`","ref":"LiveVue.SSR.html"},{"type":"function","title":"LiveVue.SSR.render/3","doc":"","ref":"LiveVue.SSR.html#render/3"},{"type":"callback","title":"LiveVue.SSR.render/3","doc":"","ref":"LiveVue.SSR.html#c:render/3"},{"type":"type","title":"LiveVue.SSR.component_name/0","doc":"","ref":"LiveVue.SSR.html#t:component_name/0"},{"type":"type","title":"LiveVue.SSR.props/0","doc":"","ref":"LiveVue.SSR.html#t:props/0"},{"type":"type","title":"LiveVue.SSR.render_response/0","doc":"A render response which should be a rendered HTML string.\n    }","ref":"LiveVue.SSR.html#t:render_response/0"},{"type":"type","title":"LiveVue.SSR.slots/0","doc":"","ref":"LiveVue.SSR.html#t:slots/0"},{"type":"module","title":"LiveVue.SSR.NodeJS","doc":"Implements SSR by using `NodeJS` package.\n\nUnder the hood, it invokes \"render\" function exposed by `server.mjs` file.\nYou can see how `server.mjs` is created by looking at `assets.deploy` command\nand `package.json` build-server script.","ref":"LiveVue.SSR.NodeJS.html"},{"type":"function","title":"LiveVue.SSR.NodeJS.render/3","doc":"","ref":"LiveVue.SSR.NodeJS.html#render/3"},{"type":"function","title":"LiveVue.SSR.NodeJS.server_path/0","doc":"","ref":"LiveVue.SSR.NodeJS.html#server_path/0"},{"type":"task","title":"mix live_vue.configure_esbuild","doc":"Creates Javascript files to be used by esbuild. Necessary for LiveVue to work.","ref":"Mix.Tasks.LiveVue.ConfigureEsbuild.html"},{"type":"function","title":"Mix.Tasks.LiveVue.ConfigureEsbuild.run/1","doc":"","ref":"Mix.Tasks.LiveVue.ConfigureEsbuild.html#run/1"},{"type":"task","title":"mix live_vue.configure_phoenix","doc":"Configures any necessary code changes inside Phoenix to make LiveVue work.","ref":"Mix.Tasks.LiveVue.ConfigurePhoenix.html"},{"type":"function","title":"Mix.Tasks.LiveVue.ConfigurePhoenix.run/1","doc":"","ref":"Mix.Tasks.LiveVue.ConfigurePhoenix.html#run/1"},{"type":"task","title":"mix live_vue.install_npm_deps","doc":"Installs npm dependencies for LiveVue.","ref":"Mix.Tasks.LiveVue.InstallNpmDeps.html"},{"type":"function","title":"Mix.Tasks.LiveVue.InstallNpmDeps.run/1","doc":"","ref":"Mix.Tasks.LiveVue.InstallNpmDeps.html#run/1"},{"type":"task","title":"mix live_vue.setup","doc":"Runs all setup tasks for LiveVue.","ref":"Mix.Tasks.LiveVue.Setup.html"},{"type":"function","title":"Mix.Tasks.LiveVue.Setup.run/1","doc":"","ref":"Mix.Tasks.LiveVue.Setup.html#run/1"},{"type":"extras","title":"README","doc":"# LiveVue\n\n[![GitHub](https://img.shields.io/github/stars/Valian/live_vue?style=social)](https://github.com/Valian/live_vue)\n[![Hex.pm](https://img.shields.io/hexpm/v/live_vue.svg)](https://hex.pm/packages/live_vue)\n\nVue inside Phoenix LiveView with seamless end-to-end reactivity.\n\n![logo](https://github.com/Valian/live_vue/blob/main/logo.png?raw=true)\n\n[Features](#features) •\n[Resources](#resources) •\n[Demo](#demo) •\n[Installation](#installation) •\n[Usage](#usage) •\n[Deployment](#deployment)","ref":"readme.html"},{"type":"extras","title":"Resources - README","doc":"-   [HexDocs](https://hexdocs.pm/live_vue)\n-   [HexPackage](https://hex.pm/packages/live_vue)\n-   [Phoenix LiveView](https://github.com/phoenixframework/phoenix_live_view)","ref":"readme.html#resources"},{"type":"extras","title":"Features - README","doc":"-   ⚡ **End-To-End Reactivity** with LiveView\n-   🔋 **Server-Side Rendered** (SSR) Vue\n-   🪄 **Sigil** as an [Alternative LiveView DSL](#livevue-as-an-alternative-liveview-dsl)\n-   🦄 **Tailwind** Support\n-   💀 **Dead View** Support\n-   🦥 **Slot Interoperability**\n-   🚀 **Amazing DX** with Vite","ref":"readme.html#features"},{"type":"extras","title":"Example - README","doc":"After installation, you can use Vue components in the same way as you'd use functional LiveView components. You can even handle Vue events with `JS` hooks! All the `phx-click`, `phx-change` attributes works inside Vue components as well.\n\n```vue\n \nimport {ref} from \"vue\"\nconst props = defineProps<{count: number}>()\nconst emit = defineEmits<{inc: [{value: number}]}>()\nconst diff = ref (\"1\")\n \n\n \n    Current count\n     {{ props.count }} \n     Diff:  \n     \n\n     \n        Increase counter by {{ diff }}\n     \n \n```\n\n```elixir\ndefmodule LiveVueExamplesWeb.LiveCounter do\n  use LiveVueExamplesWeb, :live_view\n\n  def render(assigns) do\n    ~H\"\"\"\n    <.vue\n      count={@count}\n      v-component=\"Counter\"\n      v-socket={@socket}\n      v-on:inc={JS.push(\"inc\")}\n    />\n    \"\"\"\n  end\n\n  def mount(_params, _session, socket) do\n    {:ok, assign(socket, :counter, 0)}\n  end\n\n  def handle_event(\"inc\", %{\"value\" => diff}, socket) do\n    {:noreply, update(socket, :count, &(&1 + diff))}\n  end\nend\n\n```","ref":"readme.html#example"},{"type":"extras","title":"Relation to LiveSvelte - README","doc":"This project is heavily inspired by ✨ [LiveSvelte](https://github.com/woutdp/live_svelte) ✨. Both projects try to solve the same problem. LiveVue was started as a fork fo LiveSvelte with adjusted ESbuild settings, and evolved to use Vite and a slightly different syntax. I strongly believe more options are always better, and since I love Vue and it's ecosystem I've decided to give it a go 😉","ref":"readme.html#relation-to-livesvelte"},{"type":"extras","title":"Why? - README","doc":"Phoenix Live View makes it possible to create rich, interactive web apps without writing JS.\n\nBut once you'll need to do anything even slightly complex on the client-side, you'll end up writing lots of imperative, hard-to-maintain hooks.\n\nLiveVue allows to create hybrid apps, where part of the session state is on the server and part on the client.","ref":"readme.html#why"},{"type":"extras","title":"Reasons why you'd like to use LiveVue - README","doc":"-   Your hooks are starting to look like jQuery 😅\n-   You have a complex local state\n-   You'd like to use a massive Vue ecosystem\n-   You want transitions, graphs etc.\n-   You simply like Vue 😉","ref":"readme.html#reasons-why-you-d-like-to-use-livevue"},{"type":"extras","title":"Installation - README","doc":"LiveVue replaces `esbuild` with [Vite](https://vitejs.dev/) for both client side code and SSR to achieve an amazing development experience. In production, we'll use [elixir-nodejs](https://github.com/revelrylabs/elixir-nodejs) for SSR. If you don't need SSR, you can disable it with one line of code. TypeScript will be supported as well.\n\n0. Please install `node` 😉\n\n1. Add `live_vue` to your list of dependencies of your Phoenix app in `mix.exs` and run `mix deps.get`\n\n```elixir\ndefp deps do\n  [\n    {:live_vue, \"~> 0.1\"}\n  ]\nend\n```\n\n2. Add config entry to your `config/dev.exs` file\n\n```elixir\nconfig :live_vue,\n  vite_host: \"http://localhost:5173\",\n  ssr_module: LiveVue.SSR.ViteJS,\n  # if you want to disable SSR by default, make it false\n  ssr: true\n```\n\n3. Add config entry to your `config/prod.exs` file\n\n```elixir\nconfig :live_vue,\n  ssr_module: LiveVue.SSR.NodeJS,\n  ssr: true\n```\n\n4. Add LiveVue to your `html_helpers` in `lib/my_app_web.ex`\n\n```elixir\ndefp html_helpers do\n  quote do\n    # ...\n    # Add support to Vue components\n    use LiveVue\n\n    # Generate component for each vue file, so you can omit v-component=\"name\".\n    # Right now works only for top-level files inside `assets/vue`.\n    # You can configure path to your components by using optional :vue_root param\n    use LiveVue.Components, vue_root: \"./assets/vue/*.vue\"\n  end\nend\n```\n\n5. Setup JS files. We switch esbuild to vite and add SSR entrypoint. We also add postcss config to handle tailwind and tsconfig to support TypeScript.\n\n```bash\ncd assets\n\n# vite\nnpm install -D vite @vitejs/plugin-vue\n\n# tailwind\nnpm install -D tailwindcss autoprefixer postcss @tailwindcss/forms\n\n# typescript\nnpm install -D typescript vue-tsc\n\n# runtime dependencies\nnpm install --save vue topbar ../deps/live_vue ../deps/phoenix ../deps/phoenix_html ../deps/phoenix_live_view\n\n# remove topbar from vendor, since we'll use it from node_modules\nrm vendor/topbar.js\n```\n\nNext, let's copy SSR entrypoint, vite config and typescript config from `live_vue`. If you have any of these files, they'll be skipped so you could update them on your own.\n\n```bash\nmkdir vue\n\nfor SOURCE in $(find ../deps/live_vue/assets/copy -type f); do\n  DEST=${SOURCE#../deps/live_vue/assets/copy/}\n\n  if [ -e \"$DEST\" ]; then\n    echo \"SKIPPED $SOURCE -> $DEST. Please update manually\"\n  else\n    echo \"COPIED $SOURCE -> $DEST\"\n    cp $SOURCE $DEST\n  fi\ndone\n```\n\nNow we just have to adjust app.js hooks and tailwind config to include `vue` files:\n\n```js\n// app.js\nimport topbar from \"topbar\" // instead of ../vendor/topbar\n// ...\nimport {getHooks} from \"live_vue\"\nimport components from \"../vue\"\n\nlet liveSocket = new LiveSocket(\"/live\", Socket, {\n    // ...\n    hooks: getHooks(components),\n})\n```\n\n```js\n// tailwind.config.js\n\nmodule.exports = {\n    content: [\n        // ...\n        \"./vue/**/*.vue\", // include Vue files\n    ],\n}\n```\n\nand lastly let's add helpful scripts to package.json\n\n```json\n// package.json\n{\n    \"private\": true,\n    \"type\": \"module\",\n    \"scripts\": {\n        \"dev\": \"vite --host -l warn\",\n        \"build\": \"vue-tsc && vite build\",\n        \"build-server\": \"vue-tsc && vite build --ssr js/server.js --out-dir ../priv/vue --minify esbuild && mv ../priv/vue/server.js ../priv/vue/server.mjs\"\n    },\n    \"devDependencies\": {\n        // ...\n    },\n    \"dependencies\": {\n        // ...\n    }\n}\n```\n\n6. Let's update root.html.heex to use Vite files in development. There's a handy wrapper for it.\n\n```html\n<!-- Wrap existing CSS and JS in LiveVue.Reload.vite_assets component,\npass paths to original files in assets -->\n\n \n   \n   \n   \n \n```\n\n7. Update `mix.exs` aliases and get rid of `tailwind` and `esbuild` packages\n\n```elixir\ndefp aliases do\n  [\n    setup: [\"deps.get\", \"assets.setup\", \"assets.build\"],\n    \"assets.setup\": [\"cmd --cd assets npm install\"],\n    \"assets.build\": [\n      \"cmd --cd assets npm run build\",\n      \"cmd --cd assets npm run build-server\"\n    ],\n    \"assets.deploy\": [\n      \"cmd --cd assets npm run build\",\n      \"cmd --cd assets npm run build-server\",\n      \"phx.digest\"\n    ]\n  ]\nend\n\ndefp deps do\n  [\n    # remove these lines, we don't need esbuild or tailwind here anymore\n    # {:esbuild, \"~> 0.8\", runtime: Mix.env() == :dev},\n    # {:tailwind, \"~> 0.2\", runtime: Mix.env() == :dev},\n  ]\nend\n```\n\n8. Remove esbuild and tailwind config from `config/config.exs`\n\n9. Update watchers in `config/dev.exs` to look like this\n\n```elixir\nconfig :my_app, MyAppWeb.Endpoint,\n  # ...\n  watchers: [\n    npm: [\"run\", \"dev\", cd: Path.expand(\"../assets\", __DIR__)]\n  ]\n\n```\n\n10. To make SSR working with `LiveVue.SSR.NodeJS` (recommended for production), you have to add this entry to your `application.ex` supervision tree:\n\n```elixir\nchildren = [\n  {NodeJS.Supervisor, [path: LiveVue.SSR.NodeJS.server_path(), pool_size: 4]},\n  # ...\n]\n```\n\n11. Confirm everything is working by rendering an example Vue component anywhere in your LiveViews:\n\n```elixir\n~H\"\"\"\n<.vue\n  count={@count}\n  v-component=\"Counter\"\n  v-socket={@socket}\n  v-on:inc={JS.push(\"inc\")}\n/>\n\"\"\"\n```\n\nVoila! Easy, isn't it? 😉","ref":"readme.html#installation"},{"type":"extras","title":"Usage - README","doc":"Vue components need to go into the assets/vue directory.","ref":"readme.html#usage"},{"type":"extras","title":"Basic usage - README","doc":"To render vue component from HEEX, you have to use `<.vue>` function with these attributes:\n\n| Attribute             | Example                                                   | Required        | Description                                                                                                                                                      |\n| --------------------- | --------------------------------------------------------- | --------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------- |\n| v-component           | `v-component=\"Counter\"` `v-component=\"helpers/modal\"`  | yes             | Name of the component to render. Must match key defined in `components` passed to `getHooks`, by default it's a path from `assets/vue` without extension         |\n| v-socket              | `v-socket={@socket}`                                      | Yes in LiveView | Used to determine if SSR is needed. Should be always included in LiveViews                                                                                       |\n| v-ssr                 | `v-ssr={true}`                                            | no              | Defaults to `Application.get_env(:live_vue, :ssr, true)`                                                                                                         |\n| v-on:event={@handler} | `v-on:close={JS.toggle()}`                                | no              | Handle component event by invoking JS hook. @handler has to come from `JS` module. See Usage section for more.                                                   |\n| prop={@value}         | `name=\"liveVue\"` `count={@count}` `{%{count: 123}}` | no              | All other attributes will be passed to vue component as props. Values have to be serializable to JSON, so structures have to implement `Jason.Encoder` protocol. |","ref":"readme.html#basic-usage"},{"type":"extras","title":"Shortcut - README","doc":"Instead of writing `<.vue v-component=\"Counter\">` you can use shortcut `<.Counter>`. Function names are generated based on content of `assets/vue` directory.","ref":"readme.html#shortcut"},{"type":"extras","title":"Passing props - README","doc":"You pass props in the same way as with functional components in Elixir. All 3 examples does exactly the same.\n\n```elixir\n<.vue\n  count={@count}\n  name={@name}\n  v-component=\"Counter\"\n  v-socket={@socket}\n/>\n\n<.vue\n  v-component=\"Counter\"\n  v-socket={@socket}\n  {%{count: @count, name: @name}}\n/>\n\n<.Counter\n  count={@count}\n  name={@name}\n  v-socket={@socket}\n/>\n```","ref":"readme.html#passing-props"},{"type":"extras","title":"Handling events - README","doc":"All regular phoenix hooks like `phx-click`, `phx-submit` work as expected.\nTo keep components DRY you can define vue handlers using `v-on:eventname={JS.handler()}` syntax.\nAll attributes starting with `v-on:` are attached as emit handlers to Vue components and executed in the same way as Phoenix does it.\n\n`JS.push(\"someName\")` is a special case - if JS.push defines no value, it will be replaced by the emit payload.\n\n```elixir\n<.vue v-on:submit={JS.push(\"submit\")} v-component=\"SomeForm\" v-socket={@socket} />\n<.vue\n  v-on:shoot={JS.push(\"shoot\")}\n  v-on:close={JS.hide()}\n  v-component=\"SomeGame\"\n  v-socket={@socket}\n/>\n```","ref":"readme.html#handling-events"},{"type":"extras","title":"Passing slots - README","doc":"You can even pass slots to the vue component! They're passed to vue as raw HTML, so hooks in the slots won't work. Each slot is wrapped in a div due to technical limitations.\n\n-   Default slot can be passed as `:inner_block` and rendered inside Vue components as ` `.\n-   Named slots can be passed by using `<:slot_name>Content</:slot_name>` syntax are rendered using ` ` syntax.\n-   Slots will be kept in sync, as expected.\n\nAn example:\n\n```elixir\n<.Card title=\"The coldest sunset\" v-socket={@socket}>\n   This is card content passed from phoenix! \n   Even icons are working! <.icon name=\"hero-information-circle-mini\" /> \n  <:footer>And this is a footer from phoenix</:footer>\n</.Card>\n```\n\n```vue\n \n      \n    Footer:\n      \n \n```","ref":"readme.html#passing-slots"},{"type":"extras","title":"Dead views vs Live views - README","doc":"You can use `<.vue>` components in dead views. Of course, there will be no updates on assign changes, since there is no websocket connection established to support it.\n\nv-socket={@socket} is not required in dead views.","ref":"readme.html#dead-views-vs-live-views"},{"type":"extras","title":"Note on SSR - README","doc":"Vue SSR is compiled down into string concatenation, so it's quite fast 😉\n\nIn development it's recommended to use `config :live_vue, ssr_module: LiveVue.SSR.ViteJS`. It does HTTP call to vite `/ssr_render` endpoint added by LiveVue plugin, which in turn uses vite [ssrLoadModule](https://vitejs.dev/guide/ssr) for efficient compilation.\n\nIn production it's recommended to use `config :live_vue, ssr_module: LiveVue.SSR.NodeJS` which uses `NodeJS` package directly talking with a JS process with a in-memory server bundle. By default, SSR bundle is saved to `priv/vue/server.mjs`. `mjs` extension is necessary so NodeJS correctly imports that file as `ESM module`.","ref":"readme.html#note-on-ssr"},{"type":"extras","title":"Handling custom Phoenix events client side - README","doc":"You can use function `useLiveVue` to access root phoenix element where Vue component was routed.\n\nAPI of that object is described in [Phoenix docs](https://hexdocs.pm/phoenix_live_view/js-interop.html#client-hooks-via-phx-hook).\n\nExample\n\n```vue\n \nimport {useLiveVue} from \"live_vue\"\n\nconst hook = useLiveVue()\n\nhook.pushEvent(\"hello\", {value: \"from Vue\"})\n \n```","ref":"readme.html#handling-custom-phoenix-events-client-side"},{"type":"extras","title":"Using ~V sigil to inline Vue components - README","doc":"We can go one step further and use LiveVue as an alternative to the standard LiveView DSL. This idea is taken from `LiveSvelte`.\n\nTake a look at the following example:\n\n```elixir\ndefmodule ExampleWeb.LiveSigil do\n  use ExampleWeb, :live_view\n\n  def render(assigns) do\n    ~V\"\"\"\n     \n    import {ref} from \"vue\"\n    const props = defineProps<{count: number}>()\n    const diff = ref (1)\n     \n\n     \n      Current count\n       {{ props.count }} \n       Diff:  \n       \n\n       \n        Increase counter {{ diff }}\n       \n    \"\"\"\n  end\n\n  def mount(_params, _session, socket) do\n    {:ok, assign(socket, count: 0)}\n  end\n\n  def handle_event(\"inc\", %{\"diff\" => diff}, socket) do\n    {:noreply, update(socket, :count, &(&1 + String.to_integer(diff)))}\n  end\nend\n```\n\nUse the `~V` sigil instead of `~H` and your LiveView will be Vue instead of an HEEx template.","ref":"readme.html#using-v-sigil-to-inline-vue-components"},{"type":"extras","title":"LiveVue Development - README","doc":"","ref":"readme.html#livevue-development"},{"type":"extras","title":"Local Setup - README","doc":"#### Example Project\n\nYou can use `/example_project` as a way to test `live_vue` locally.\n\n#### Custom Project\n\nYou can also use your own project.\n\nClone `live_vue` to the parent directory of the project you want to test it in.\n\nInside `mix.exs`\n\n```elixir\n{:live_vue, path: \"../live_vue\"},\n```\n\nInside `assets/package.json`\n\n```javascript\n\"live_vue\": \"file:../../live_vue\",\n```","ref":"readme.html#local-setup"},{"type":"extras","title":"Building Static Files - README","doc":"Make the changes in `/assets/js` and run:\n\n```bash\nmix assets.build\n```\n\nOr run the watcher:\n\n```bash\nmix assets.build --watch\n```","ref":"readme.html#building-static-files"},{"type":"extras","title":"Releasing - README","doc":"-   Update the version in `README.md`\n-   Update the version in `package.json`\n-   Update the version in `mix.exs`\n-   Update the changelog\n\nRun:\n\n```bash\nmix hex.publish\n```","ref":"readme.html#releasing"},{"type":"extras","title":"Deployment - README","doc":"Deploying a LiveVue app is the same as deploying a regular Phoenix app, except that you will need to ensure that `nodejs` (version 19 or later) is installed in your production environment.\n\nThe below guide shows how to deploy a LiveVue app to [Fly.io](https://fly.io/), but similar steps can be taken to deploy to other hosting providers.\nYou can find more information on how to deploy a Phoenix app [here](https://hexdocs.pm/phoenix/deployment.html).","ref":"readme.html#deployment"},{"type":"extras","title":"Deploying on Fly.io - README","doc":"The following steps are needed to deploy to Fly.io. This guide assumes that you'll be using Fly Postgres as your database. Further guidance on how to deploy to Fly.io can be found [here](https://fly.io/docs/elixir/getting-started/).\n\n1. Generate a `Dockerfile`:\n\n```bash\nmix phx.gen.release --docker\n```\n\n2. Modify the generated `Dockerfile` to install `curl`, which is used to install `nodejs` (version 19 or greater), and also add a step to install our `npm` dependencies:\n\n```diff\n# ./Dockerfile\n\n...\n\n# install build dependencies\n- RUN apt-get update -y && apt-get install -y build-essential git \\\n+ RUN apt-get update -y && apt-get install -y build-essential git curl \\\n    && apt-get clean && rm -f /var/lib/apt/lists/*_*\n\n+ # install nodejs for build stage\n+ RUN curl -fsSL https://deb.nodesource.com/setup_19.x | bash - && apt-get install -y nodejs\n\n...\n\nCOPY assets assets\n\n+ # install all npm packages in assets directory\n+ WORKDIR /app/assets\n+ RUN npm install\n\n+ # change back to build dir\n+ WORKDIR /app\n\n...\n\n# start a new build stage so that the final image will only contain\n# the compiled release and other runtime necessities\nFROM ${RUNNER_IMAGE}\n\nRUN apt-get update -y && \\\n-  apt-get install -y libstdc++6 openssl libncurses5 locales ca-certificates \\\n+  apt-get install -y libstdc++6 openssl libncurses5 locales ca-certificates curl \\\n   && apt-get clean && rm -f /var/lib/apt/lists/*_*\n\n+ # install nodejs for production environment\n+ RUN curl -fsSL https://deb.nodesource.com/setup_19.x | bash - && apt-get install -y nodejs\n\n...\n```\n\nNote: `nodejs` is installed BOTH in the build stage and in the final image. This is because we need `nodejs` to install our `npm` dependencies and also need it when running our app.\n\n3. Launch your app with the Fly.io CLI:\n\n```bash\nfly launch\n```\n\n4. When prompted to tweak settings, choose `y`:\n\n```bash\n? Do you want to tweak these settings before proceeding? (y/N) y\n```\n\nThis will launch a new window where you can tweak your launch settings. In the database section, choose `Fly Postgres` and enter a name for your database. You may also want to change your database to the development configuration to avoid extra costs. You can leave the rest of the settings as-is unless you want to change them.\n\nDeployment will continue once you hit confirm.\n\n5. Once the deployment completes, run the following command to see your deployed app!\n\n```bash\nfly apps open\n```","ref":"readme.html#deploying-on-fly-io"},{"type":"extras","title":"Credits - README","doc":"[LiveSvelte](https://github.com/woutdp/live_svelte)","ref":"readme.html#credits"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}